<template>
  <v-card class="tip-calculator">
    <v-card-title>{{ title }}</v-card-title>
    <form>
      <div class="form-row">
        <v-text-field
          id="subTotal"
          label="Subtotal:"
          name="subTotal"
          v-model="$v.subTotal.$model"
        ></v-text-field>
        <div v-if="$v.subTotal.$dirty">
          <p class="error-txt" v-if="!$v.subTotal.required">
            Subtotal is required.
          </p>
          <p class="error-txt" v-if="!$v.subTotal.minValue">
            Subtotal must be at least .01.
          </p>
          <p class="error-txt" v-if="!$v.subTotal.decimal">
            Subtotal must be numeric.
          </p>
        </div>
      </div>
      <div class="form-row">
        <v-text-field
          id="partySize"
          label="Party Size:"
          name="partySize"
          v-model="$v.partySize.$model"
        ></v-text-field>
        <div v-if="$v.partySize.$dirty">
          <p class="error-txt" v-if="!$v.partySize.maxValue">
            Party size cannot be more than 20.
          </p>
          <p class="error-txt" v-if="!$v.partySize.minValue">
            Party size must be at least 1.
          </p>
          <p class="error-txt" v-if="!$v.partySize.numeric">
            Party size must be numeric.
          </p>
          <p class="error-txt" v-if="!$v.partySize.required">
            Party size is required.
          </p>
        </div>
      </div>
      <div class="form-row">
        <label for="tip">Tip Percentage:</label>
        <select id="tip" name="tip" v-model="$v.tip.$model">
          <option :value="null"></option>
          <option v-for="t in tipList" :key="t">{{ t }}</option>
        </select>
        <v-select name="tip" v-model="$v.tip.$model"
                  :items="splits"
        ></v-select>
        <span class="tip-message" v-if="tipNone"
          >Thank You For Choosing Us.</span
        >
        <span class="tip-message" v-if="tipGood">Thank You For The Tip!</span>
        <span class="tip-message" v-if="tipGreat"
          >Awesome Tip! Thank You So Much!</span
        >
        <div v-if="$v.tip.$dirty">
          <p class="error-txt" v-if="!$v.tip.required">
            Tip percentage is required.
          </p>
        </div>
      </div>
      <div class="form-row align-right">
        <v-btn
          @click.stop.prevent="calculate()"
          :disabled="!allowCalculate"
          type="v-btn"
        >
          Calculate
        </v-btn>
      </div>
      <div v-if="total">
        <div class="form-row">
          <label>Tip:</label>
          {{ tipAmount | toCurrency }}
        </div>
        <div class="form-row">
          <label>Total:</label>
          {{ total | toCurrency }}
        </div>
        <div class="form-row" v-if="partySize > 1">
          <label></label>
          <v-btn @click.stop.prevent="openSplit()" v-if="!enableSplit">
            Split The Check
          </v-btn>
          <v-btn
            @click.stop.prevent="closeSplit()"
            v-if="enableSplit"
            class="btn-danger"
          >
            Don't Split The Check
          </v-btn>
        </div>
        <div v-if="enableSplit">
          <div
            class="form-row"
            v-for="(split, index) in splits.slice(0, splits.length - 1)"
            :key="index"
          >
            <label>Split {{ index + 1 }}:</label>
            <select
              :id="'splitType' + index"
              :name="'splitType' + index"
              v-model="split.type"
            >
              <option value="dollars">$</option>
              <option value="percent">%</option>
            </select>
            <v-text-field
              :name="'amount' + index"
              label="Amount"
              class="sm"
              v-model="split.amount"
            ></v-text-field>
            <v-btn
              @click.stop.prevent="removeSplit(index)"
              v-if="splits.length > 2"
              class="btn-danger"
            >
              X
            </v-btn>
          </div>
          <div class="form-row">
            <label>Split {{ splits.length }}:</label>
            <select v-model="lastSplit.type" disabled>
              <option value="dollars">Rest</option>
            </select>
            <v-text-input class="sm" v-if="lastSplit.type === 'dollars'" disabled />
          </div>
          <div class="form-row">
            <v-btn
              @click.stop.prevent="addSplit()"
              v-if="splits.length < partySize"
            >
              Add Split
            </v-btn>
            <v-btn disabled v-if="splits.length === Number(partySize)">
              Cannot Add More Splits
            </v-btn>
          </div>
        </div>
      </div>
    </form>
  </v-card>
</template>

<script>
import decimal from "vuelidate/lib/validators/decimal";
import maxValue from "vuelidate/lib/validators/maxValue";
import minValue from "vuelidate/lib/validators/minValue";
import numeric from "vuelidate/lib/validators/numeric";
import required from "vuelidate/lib/validators/required";
import toCurrency from "../filters/toCurrency";

export default {
  name: "TipCalculator",
  computed: {
    allowCalculate: function() {
      return this.$v.$dirty && !this.$v.invalid;
    },
    disableSplit: function() {
      return !this.partySize || Number(this.partySize) === 1;
    },
    lastSplit: function() {
      return this.splits[this.splits.length - 1];
    },
    tipNone: function() {
      return this.tip !== null && Number(this.tip) === 0;
    },
    tipGood: function() {
      return ["10", "15"].includes(this.tip);
    },
    tipGreat: function() {
      return ["18", "20"].includes(this.tip);
    }
  },
  created() {
    this.resetSplits();
  },
  data() {
    return {
      enableSplit: false,
      isSubmitting: false,
      partySize: null,
      splits: [],
      subTotal: null,
      tip: null,
      tipAmount: null,
      tipList: [0, 10, 15, 18, 20],
      tipPercentage: null,
      total: null
    };
  },
  filters: {
    toCurrency
  },
  methods: {
    calculate: function() {
      this.tipAmount = this.subTotal * (this.tip / 100);
      this.total = Number(this.tipAmount) + Number(this.subTotal);

      let totalSplit = 0;
      this.splits.forEach(split => {
        if (split.type === "dollar" && split.amount) {
          totalSplit += split.amount;
        }
      });

      if (totalSplit === 0) {
        const evenSplit = totalSplit / this.splits.length;
        this.splits.forEach(split => {
          split.amount = evenSplit;
        })
      }
    },
    addSplit: function() {
      if (this.splits.length < this.partySize) {
        this.splits.push({ type: "dollars", amount: "", percentage: "" });
      }
    },
    closeSplit: function() {
      this.enableSplit = false;
    },
    openSplit: function() {
      this.enableSplit = true;
    },
    removeSplit: function(index) {
      this.splits.splice(index, 1);
    },
    resetSplits: function() {
      this.splits = [
        { type: "dollars", amount: null },
        { type: "dollars", amount: null }
      ];
    }
  },
  props: {
    title: String
  },
  validations: {
    partySize: {
      maxValue: maxValue(20),
      minValue: minValue(1),
      numeric,
      required
    },
    subTotal: {
      minValue: minValue(0.01),
      decimal,
      required
    },
    tip: {
      numeric,
      required
    }
  }
};
</script>

<style scoped lang="scss">
v-text-input {
  border: #333 solid 2px;
  padding: 10px;
  width: 286px;
  &.sm {
    margin-left: 10px;
    width: 75px;
  }
}

v-btn,
select {
  border: #333 solid 2px;
  padding: 9px 10px;
}

.align-right {
  text-align: right;
}

.error-txt {
  color: red;
}

.form-row {
  margin-bottom: 10px;

  label {
    display: inline-block;
    font-weight: bold;
    width: 100px;
  }
}

.tip-calculator {
  margin: auto;
  width: 410px;
}

.tip-message {
  padding-left: 10px;
}

.btn-danger {
  background: #ff0000;
  border: 2px #d50000 solid;
  color: #fff;
}
</style>
